--- chan_unistim.c.orig	2011-10-11 11:33:06.000000000 -0500
+++ chan_unistim.c	2011-10-11 11:42:22.000000000 -0500
@@ -2706,49 +3295,36 @@
 			keycode = pte->device->phone_number[pte->device->size_phone_number] + 0x10;
 		}
 	}
+	if (keycode == KEY_SHARP && pte->device->sharp_dial == 1) {
+		keycode = KEY_FUNC1;
+	}
 	if ((keycode >= KEY_0) && (keycode <= KEY_SHARP)) {
-		char tmpbuf[] = "Number : ...............";
-		int i = 0;
+		int i = pte->device->size_phone_number;
 
-		if (pte->device->size_phone_number >= 15)
-			return;
 		if (pte->device->size_phone_number == 0)
 			send_tone(pte, 0, 0);
-		while (i < pte->device->size_phone_number) {
-			tmpbuf[i + 9] = pte->device->phone_number[i];
-			i++;
-		}
-		if (keycode == KEY_SHARP)
+
+		if (keycode == KEY_SHARP) 
 			keycode = '#';
 		else if (keycode == KEY_STAR)
 			keycode = '*';
 		else
 			keycode -= 0x10;
-		tmpbuf[i + 9] = keycode;
 		pte->device->phone_number[i] = keycode;
 		pte->device->size_phone_number++;
 		pte->device->phone_number[i + 1] = 0;
-		if (pte->device->height == 1) {
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, tmpbuf);
+		show_phone_number(pte);
+		
+		if (ast_exists_extension(NULL, pte->device->context, pte->device->phone_number, 1, NULL) && 
+			!ast_matchmore_extension(NULL, pte->device->context, pte->device->phone_number, 1, NULL)) {
+		    keycode = KEY_FUNC1;
 		} else {
-			send_text(TEXT_LINE2, TEXT_NORMAL, pte, tmpbuf);
+		    pte->device->nextdial = get_tick_count() + TIMER_DIAL;
 		}
-		send_blink_cursor(pte);
-		send_cursor_pos(pte, (unsigned char) (TEXT_LINE2 + 0x0a + i));
-		return;
 	}
 	if (keycode == KEY_FUNC4) {
-
 		pte->device->size_phone_number = 0;
-		if (pte->device->height == 1) {
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Number : ...............");
-			send_blink_cursor(pte);
-			send_cursor_pos(pte, TEXT_LINE0 + 0x09);
-		} else {
-			send_text(TEXT_LINE2, TEXT_NORMAL, pte, "Number : ...............");
-			send_blink_cursor(pte);
-			send_cursor_pos(pte, TEXT_LINE2 + 0x09);
-		}
+		show_phone_number(pte);
 		return;
 	}
 
@@ -2759,6 +3335,8 @@
 			show_main_page(pte);
 		} else if ((keycode == KEY_FUNC2) || (keycode == KEY_HANGUP)) {
 			pte->device->call_forward[0] = '\0';
+			send_led_update(pte, 0x08);
+			send_led_update(pte, 0x10);
 			show_main_page(pte);
 		}
 		return;
@@ -2770,40 +3348,38 @@
 		ast_copy_string(pte->device->phone_number, pte->device->redial_number,
 						sizeof(pte->device->phone_number));
 	case KEY_FUNC1:
-		HandleCallOutgoing(pte);
+		handle_call_outgoing(pte);
 		break;
 	case KEY_HANGUP:
-		if (pte->device->lines->subs[SUB_REAL]->owner) {
-			/* Stop the silence generator */
-			if (pte->device->silence_generator) {
-				if (unistimdebug)
-					ast_verb(0, "Stopping silence generator\n");
-				ast_channel_stop_silence_generator(pte->device->lines->subs[SUB_REAL]->
-												   owner, pte->device->silence_generator);
-				pte->device->silence_generator = NULL;
-			}
+		if (sub && sub->owner) {
+			struct ast_channel *bridgepeer = NULL;
+
+			sub_stop_silence(pte, sub);
 			send_tone(pte, 0, 0);
-			ast_moh_stop(ast_bridged_channel(pte->device->lines->subs[SUB_REAL]->owner));
-			pte->device->moh = 0;
+			if ((bridgepeer = ast_bridged_channel(sub->owner))) {
+				ast_moh_stop(bridgepeer);
+			}
+			sub->moh = 0;
+			sub->subtype = SUB_REAL;
 			pte->state = STATE_CALL;
 
-			if (pte->device->height == 1) {
-				send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Dial Cancel,back to priv. call.");
-			} else {
-				send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Dialing canceled,");
-				send_text(TEXT_LINE1, TEXT_NORMAL, pte, "switching back to");
-				send_text(TEXT_LINE2, TEXT_NORMAL, pte, "previous call.");
-			}
-			send_text_status(pte, "Hangup Transf");
-		} else
+			send_text_status(pte, ustmtext("       Transf        Hangup", pte));
+			send_callerid_screen(pte, sub);
+		} else {                        
+			send_led_update(pte, 0x08);
+			send_led_update(pte, 0x10);
 			show_main_page(pte);
+                }
 		break;
+	case KEY_FAV0:
 	case KEY_FAV1:
 	case KEY_FAV2:
 	case KEY_FAV3:
 	case KEY_FAV4:
 	case KEY_FAV5:
-		Keyfavorite(pte, keycode);
+		send_favorite_selected(FAV_LINE_ICON, pte);
+		pte->device->selected = -1;
+		handle_key_fav(pte, keycode);
 		break;
 	case KEY_LOUDSPK:
 		if (pte->device->output == OUTPUT_SPEAKER) {
@@ -2828,16 +3404,57 @@
 	return;
 }
 
+static void handle_select_option(struct unistimsession *pte)
+{
+	char tmp[128];
+
+	if (pte->state != STATE_SELECTOPTION) {
+		pte->state = STATE_SELECTOPTION;
+		pte->size_buff_entry = 1;
+		pte->buff_entry[0] = 0; /* Position in menu */
+	}
+	snprintf(tmp, sizeof(tmp), "%d. %s", pte->buff_entry[0] + 1, ustmtext(options_menu[(int)pte->buff_entry[0]].label, pte));
+	send_text(TEXT_LINE0, TEXT_NORMAL, pte, tmp);
+	send_text_status(pte, ustmtext("Select               Cancel", pte));
+	return;
+}
+
+static void key_select_option(struct unistimsession *pte, char keycode)
+{
+	switch (keycode) {
+	case KEY_DOWN:
+		pte->buff_entry[0]++;
+		if (options_menu[(int)pte->buff_entry[0]].label == NULL)
+			pte->buff_entry[0]--;
+		break;
+	case KEY_UP:
+		if (pte->buff_entry[0] > 0)
+			pte->buff_entry[0]--;
+		break;
+	case KEY_LOUDSPK:
+	case KEY_FUNC1:
+		options_menu[(int)pte->buff_entry[0]].handle_option(pte);
+		return;
+	case KEY_HANGUP:
+	case KEY_FUNC4:
+		show_main_page(pte);
+		return;
+	}
+
+	handle_select_option(pte);
+	return;
+}
+
 #define SELECTCODEC_START_ENTRY_POS 15
 #define SELECTCODEC_MAX_LENGTH 2
 #define SELECTCODEC_MSG "Codec number : .."
-static void HandleSelectCodec(struct unistimsession *pte)
+static void handle_select_codec(struct unistimsession *pte)
 {
 	char buf[30], buf2[5];
 
 	pte->state = STATE_SELECTCODEC;
-	strcpy(buf, "Using codec ");
-	sprintf(buf2, "%d", pte->device->codec_number);
+	ast_copy_string(buf, ustmtext("Using codec", pte), sizeof(buf));
+	snprintf(buf2, sizeof(buf2), " %d", pte->device->codec_number);
 	strcat(buf, buf2);
 	strcat(buf, " (G711u=0,");
 
@@ -2847,7 +3464,7 @@
 	send_blink_cursor(pte);
 	send_cursor_pos(pte, TEXT_LINE2 + SELECTCODEC_START_ENTRY_POS);
 	pte->size_buff_entry = 0;
-	send_text_status(pte, "Select BackSpcErase  Cancel");
+	send_text_status(pte, ustmtext("Select BackSp Erase  Cancel", pte));
 	return;
 }
 
@@ -2905,19 +3522,82 @@
 	return;
 }
 
+static int find_language(const char* lang)
+{
+	int i = 0;
+	while (options_languages[i].lang_short != NULL) {
+		if(!strcmp(options_languages[i].lang_short, lang))
+			return i;
+		i++;
+	}
+	return 0;
+}
+
+static void handle_select_language(struct unistimsession *pte)
+{
+	char tmp_language[40];
+	struct unistim_languages lang;
+
+	if (pte->state != STATE_SELECTLANGUAGE) {
+		pte->state = STATE_SELECTLANGUAGE;
+		pte->size_buff_entry = 1;
+		pte->buff_entry[0] = find_language(pte->device->language);
+	}
+	lang = options_languages[(int)pte->buff_entry[0]];
+	ast_copy_string(tmp_language, pte->device->language, sizeof(tmp_language));
+	ast_copy_string(pte->device->language, lang.lang_short, sizeof(pte->device->language));
+	send_charset_update(pte, lang.encoding);
+	send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext(lang.label, pte));
+
+	ast_copy_string(pte->device->language, tmp_language, sizeof(pte->device->language));
+	lang = options_languages[find_language(pte->device->language)];
+	send_charset_update(pte, lang.encoding);
+	send_text_status(pte, ustmtext("Select               Cancel", pte));
+	return;
+}
+
+static void key_select_language(struct unistimsession *pte, char keycode)
+{
+	switch (keycode) {
+	case KEY_DOWN:
+		pte->buff_entry[0]++;
+		if (options_languages[(int)pte->buff_entry[0]].label == NULL)
+			pte->buff_entry[0]--;
+		break;
+	case KEY_UP:
+		if (pte->buff_entry[0] > 0)
+			pte->buff_entry[0]--;
+		break;
+	case KEY_FUNC1:
+		ast_copy_string(pte->device->language, options_languages[(int)pte->buff_entry[0]].lang_short, sizeof(pte->device->language));
+		send_charset_update(pte, options_languages[(int)pte->buff_entry[0]].encoding);
+		refresh_all_favorite(pte);
+		show_main_page(pte);
+		return;
+	case KEY_HANGUP:
+	case KEY_FUNC4:
+		handle_select_option(pte);
+		return;
+	}
+
+	handle_select_language(pte);
+	return;
+}
+
+
 #define SELECTEXTENSION_START_ENTRY_POS 0
 #define SELECTEXTENSION_MAX_LENGTH 10
 #define SELECTEXTENSION_MSG ".........."
-static void ShowExtensionPage(struct unistimsession *pte)
+static void show_extension_page(struct unistimsession *pte)
 {
 	pte->state = STATE_EXTENSION;
 
-	send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Please enter a Terminal");
-	send_text(TEXT_LINE1, TEXT_NORMAL, pte, "Number (TN) :");
+	send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext("Please enter a Terminal", pte));
+	send_text(TEXT_LINE1, TEXT_NORMAL, pte, ustmtext("Number (TN) :", pte));
 	send_text(TEXT_LINE2, TEXT_NORMAL, pte, SELECTEXTENSION_MSG);
 	send_blink_cursor(pte);
 	send_cursor_pos(pte, TEXT_LINE2 + SELECTEXTENSION_START_ENTRY_POS);
-	send_text_status(pte, "Enter  BackSpcErase");
+	send_text_status(pte, ustmtext("Enter  BackSpcErase", pte));
 	pte->size_buff_entry = 0;
 	return;
 }
@@ -2972,7 +3652,6 @@
 						pte->device = d;
 						d->session = pte;
 						d->codec_number = DEFAULT_CODEC;
-						d->pos_fav = 0;
 						d->missed_call = 0;
 						d->receiver_state = STATE_ONHOOK;
 						strcpy(d->id, pte->macaddr);
@@ -2989,8 +3668,8 @@
 				d = d->next;
 			}
 			ast_mutex_unlock(&devicelock);
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Invalid Terminal Number.");
-			send_text(TEXT_LINE1, TEXT_NORMAL, pte, "Please try again :");
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext("Invalid Terminal Number.", pte));
+			send_text(TEXT_LINE1, TEXT_NORMAL, pte, ustmtext("Please try again :", pte));
 			send_cursor_pos(pte,
 						  (unsigned char) (TEXT_LINE2 + SELECTEXTENSION_START_ENTRY_POS +
 										   pte->size_buff_entry));
@@ -2998,9 +3677,9 @@
 		} else {
 			ast_copy_string(pte->device->extension_number, pte->buff_entry,
 							pte->size_buff_entry + 1);
-			if (RegisterExtension(pte)) {
-				send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Invalid extension.");
-				send_text(TEXT_LINE1, TEXT_NORMAL, pte, "Please try again :");
+			if (register_extension(pte)) {
+				send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext("Invalid extension.", pte));
+				send_text(TEXT_LINE1, TEXT_NORMAL, pte, ustmtext("Please try again :", pte));
 				send_cursor_pos(pte,
 							  (unsigned char) (TEXT_LINE2 +
 											   SELECTEXTENSION_START_ENTRY_POS +
@@ -3020,12 +3699,14 @@
 	return;
 }
 
-static int ReformatNumber(char *number)
+/*
+static int reformat_number(char *number)
 {
 	int pos = 0, i = 0, size = strlen(number);
 
 	for (; i < size; i++) {
-		if ((number[i] >= '0') && (number[i] <= '9')) {
+		if (((number[i] >= '0') && (number[i] <= '9')) ||
+			(number[i] == '*') || (number[i] == '#') || (number[i] == '+')) {
 			if (i == pos) {
 				pos++;
 				continue;
@@ -3037,6 +3718,7 @@
 	number[pos] = 0;
 	return pos;
 }
+*/
 
 static void show_entry_history(struct unistimsession *pte, FILE ** f)
 {
@@ -3049,7 +3731,12 @@
 		return;
 	}
 	line[sizeof(line) - 1] = '\0';
-	send_text(TEXT_LINE0, TEXT_NORMAL, pte, line);
+	if (pte->device->height == 1) {
+		if (pte->buff_entry[3] == 1)
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, line);
+	} else {
+		send_text(TEXT_LINE0, TEXT_NORMAL, pte, line);
+	}
 	if (fread(line, TEXT_LENGTH_MAX, 1, *f) != 1) {
 		display_last_error("Can't read callerid entry");
 		fclose(*f);
@@ -3057,37 +3744,48 @@
 	}
 	line[sizeof(line) - 1] = '\0';
 	ast_copy_string(pte->device->lst_cid, line, sizeof(pte->device->lst_cid));
-	send_text(TEXT_LINE1, TEXT_NORMAL, pte, line);
+	if (pte->device->height == 1) {
+		if (pte->buff_entry[3] == 2)
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, line);
+	} else {
+		send_text(TEXT_LINE1, TEXT_NORMAL, pte, line);
+	}
 	if (fread(line, TEXT_LENGTH_MAX, 1, *f) != 1) {
 		display_last_error("Can't read callername entry");
 		fclose(*f);
 		return;
 	}
 	line[sizeof(line) - 1] = '\0';
-	send_text(TEXT_LINE2, TEXT_NORMAL, pte, line);
+	if (pte->device->height == 1) {
+		if (pte->buff_entry[3] == 3)
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, line);
+        } else {
+                send_text(TEXT_LINE2, TEXT_NORMAL, pte, line);
+        }
 	fclose(*f);
 
-	snprintf(line, sizeof(line), "Call %03d/%03d", pte->buff_entry[2],
+	snprintf(line, sizeof(line), "%s %03d/%03d", ustmtext("Call", pte), pte->buff_entry[2],
 			 pte->buff_entry[1]);
 	send_texttitle(pte, line);
 
 	if (pte->buff_entry[2] == 1)
-		strcpy(func1, "       ");
+		ast_copy_string(func1, "       ", sizeof(func1));
 	else
-		strcpy(func1, "Prvious");
+		ast_copy_string(func1, ustmtext("Prev   ", pte), sizeof(func1));
 	if (pte->buff_entry[2] >= pte->buff_entry[1])
-		strcpy(func2, "       ");
+		ast_copy_string(func2, "       ", sizeof(func2));
 	else
-		strcpy(func2, "Next   ");
-	if (ReformatNumber(pte->device->lst_cid))
-		strcpy(func3, "Redial ");
+		ast_copy_string(func2, ustmtext("Next   ", pte), sizeof(func2));
+	if (strlen(pte->device->lst_cid))
+		ast_copy_string(func3, ustmtext("Redial ", pte), sizeof(func3));
 	else
-		strcpy(func3, "       ");
-	snprintf(status, sizeof(status), "%s%s%sCancel", func1, func2, func3);
+		ast_copy_string(func3, "       ", sizeof(func3));
+
+	snprintf(status, sizeof(status), "%s%s%s%s", func1, func2, func3, ustmtext("Cancel", pte));
 	send_text_status(pte, status);
 }
 
-static char OpenHistory(struct unistimsession *pte, char way, FILE ** f)
+static char open_history(struct unistimsession *pte, char way, FILE ** f)
 {
 	char tmp[AST_CONFIG_MAX_PATH];
 	char count;
@@ -3122,12 +3820,13 @@
 		return;
 	if (!pte->device->callhistory)
 		return;
-	count = OpenHistory(pte, way, &f);
+	count = open_history(pte, way, &f);
 	if (!count)
 		return;
 	pte->buff_entry[0] = way;
 	pte->buff_entry[1] = count;
 	pte->buff_entry[2] = 1;
+	pte->buff_entry[3] = 1;
 	show_entry_history(pte, &f);
 	pte->state = STATE_HISTORY;
 }
@@ -3135,60 +3834,74 @@
 static void show_main_page(struct unistimsession *pte)
 {
 	char tmpbuf[TEXT_LENGTH_MAX + 1];
-
+	const char *text;
 
 	if ((pte->device->extension == EXTENSION_ASK) &&
 		(ast_strlen_zero(pte->device->extension_number))) {
-		ShowExtensionPage(pte);
+		show_extension_page(pte);
 		return;
 	}
 
 	pte->state = STATE_MAINPAGE;
 
 	send_tone(pte, 0, 0);
+	send_stop_timer(pte); /* case of holding call */
 	send_select_output(pte, pte->device->output, pte->device->volume, MUTE_ON_DISCRET);
-	pte->device->lines->lastmsgssent = 0;
-	send_favorite(pte->device->softkeylinepos, FAV_ICON_ONHOOK_BLACK, pte,
-				 pte->device->softkeylabel[pte->device->softkeylinepos]);
+	send_led_update(pte, 0x08);
+	send_led_update(pte, 0x10);
+
 	if (!ast_strlen_zero(pte->device->call_forward)) {
 		if (pte->device->height == 1) {
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Forwarding ON");
+			char tmp_field[100];
+			snprintf(tmp_field, sizeof(tmp_field), "%s %s", ustmtext("Fwd to:", pte), pte->device->call_forward);
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, tmp_field);
 		} else {
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Call forwarded to :");
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext("Call forwarded to :", pte));
 			send_text(TEXT_LINE1, TEXT_NORMAL, pte, pte->device->call_forward);
 		}
-		Sendicon(TEXT_LINE0, FAV_ICON_REFLECT + FAV_BLINK_SLOW, pte);
-		send_text_status(pte, "Dial   Redial NoForwd");
+		send_icon(TEXT_LINE0, FAV_ICON_REFLECT + FAV_BLINK_SLOW, pte);
+		send_text_status(pte, ustmtext("Dial   Redial NoFwd  ", pte));
 	} else {
 		if ((pte->device->extension == EXTENSION_ASK) ||
 			(pte->device->extension == EXTENSION_TN))
-			send_text_status(pte, "Dial   Redial ForwardUnregis");
+			send_text_status(pte, ustmtext("Dial   Redial Fwd    Unregis", pte));
 		else
-			send_text_status(pte, "Dial   Redial Forward");
+			send_text_status(pte, ustmtext("Dial   Redial Fwd    Pickup", pte));
 
 		send_text(TEXT_LINE1, TEXT_NORMAL, pte, pte->device->maintext1);
-		if (pte->device->missed_call == 0)
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, pte->device->maintext0);
-		else {
-			sprintf(tmpbuf, "%d unanswered call(s)", pte->device->missed_call);
+		if (pte->device->missed_call == 0) {
+			send_date_time2(pte);
+			send_idle_clock(pte);
+			if (strlen(pte->device->maintext0))
+				send_text(TEXT_LINE0, TEXT_NORMAL, pte, pte->device->maintext0);
+		} else {
+			if (pte->device->missed_call == 1) {
+				text = ustmtext("unanswered call", pte);
+			} else {
+				text = ustmtext("unanswered calls", pte);
+			}
+			snprintf(tmpbuf, sizeof(tmpbuf), "%d %s", pte->device->missed_call, text);
 			send_text(TEXT_LINE0, TEXT_NORMAL, pte, tmpbuf);
-			Sendicon(TEXT_LINE0, FAV_ICON_CALL_CENTER + FAV_BLINK_SLOW, pte);
+			send_icon(TEXT_LINE0, FAV_ICON_CALL_CENTER + FAV_BLINK_SLOW, pte);
 		}
 	}
-	if (ast_strlen_zero(pte->device->maintext2)) {
-		strcpy(tmpbuf, "IP : ");
-		strcat(tmpbuf, ast_inet_ntoa(pte->sin.sin_addr));
-		send_text(TEXT_LINE2, TEXT_NORMAL, pte, tmpbuf);
-	} else
-		send_text(TEXT_LINE2, TEXT_NORMAL, pte, pte->device->maintext2);
+	if (pte->device->height > 1) {
+		if (ast_strlen_zero(pte->device->maintext2)) {
+			strcpy(tmpbuf, "IP : ");
+			strcat(tmpbuf, ast_inet_ntoa(pte->sin.sin_addr));
+			send_text(TEXT_LINE2, TEXT_NORMAL, pte, tmpbuf);
+		} else
+			send_text(TEXT_LINE2, TEXT_NORMAL, pte, pte->device->maintext2);
+	}
+
 	send_texttitle(pte, pte->device->titledefault);
-	change_favorite_icon(pte, FAV_ICON_ONHOOK_BLACK);
+	change_favorite_icon(pte, FAV_LINE_ICON);
 }
 
 static void key_main_page(struct unistimsession *pte, char keycode)
 {
 	if (pte->device->missed_call) {
-		Sendicon(TEXT_LINE0, FAV_ICON_NONE, pte);
+		send_icon(TEXT_LINE0, FAV_ICON_NONE, pte);
 		pte->device->missed_call = 0;
 	}
 	if ((keycode >= KEY_0) && (keycode <= KEY_SHARP)) {
@@ -3198,6 +3911,7 @@
 	}
 	switch (keycode) {
 	case KEY_FUNC1:
+		pte->device->selected = get_avail_softkey(pte, NULL);
 		handle_dial_page(pte);
 		break;
 	case KEY_FUNC2:
@@ -3211,7 +3925,7 @@
 
 		ast_copy_string(pte->device->phone_number, pte->device->redial_number,
 						sizeof(pte->device->phone_number));
-		HandleCallOutgoing(pte);
+		handle_call_outgoing(pte);
 		break;
 	case KEY_FUNC3:
 		if (!ast_strlen_zero(pte->device->call_forward)) {
@@ -3219,7 +3933,7 @@
 			memmove(pte->device->call_forward + 1, pte->device->call_forward,
 					sizeof(pte->device->call_forward));
 			pte->device->call_forward[0] = '\0';
-			Sendicon(TEXT_LINE0, FAV_ICON_NONE, pte);
+			send_icon(TEXT_LINE0, FAV_ICON_NONE, pte);
 			pte->device->output = OUTPUT_HANDSET;   /* Seems to be reseted somewhere */
 			show_main_page(pte);
 			break;
@@ -3229,9 +3943,9 @@
 		break;
 	case KEY_FUNC4:
 		if (pte->device->extension == EXTENSION_ASK) {
-			UnregisterExtension(pte);
+			unregister_extension(pte);
 			pte->device->extension_number[0] = '\0';
-			ShowExtensionPage(pte);
+			show_extension_page(pte);
 		} else if (pte->device->extension == EXTENSION_TN) {
 			ast_mutex_lock(&devicelock);
 			strcpy(pte->device->id, pte->device->extension_number);
@@ -3240,26 +3954,24 @@
 			pte->device->session = NULL;
 			pte->device = NULL;
 			ast_mutex_unlock(&devicelock);
-			ShowExtensionPage(pte);
-		}
+			show_extension_page(pte);
+		} else { /* Pickup function */
+			pte->device->selected = -1;
+			ast_copy_string(pte->device->phone_number, ast_pickup_ext(),
+						sizeof(pte->device->phone_number));
+			handle_call_outgoing(pte);
+                }
 		break;
 	case KEY_FAV0:
-		handle_dial_page(pte);
-		break;
 	case KEY_FAV1:
 	case KEY_FAV2:
 	case KEY_FAV3:
 	case KEY_FAV4:
 	case KEY_FAV5:
-		if ((pte->device->output == OUTPUT_HANDSET) &&
-			(pte->device->receiver_state == STATE_ONHOOK))
-			send_select_output(pte, OUTPUT_SPEAKER, pte->device->volume, MUTE_OFF);
-		else
-			send_select_output(pte, pte->device->output, pte->device->volume, MUTE_OFF);
-		Keyfavorite(pte, keycode);
+		handle_key_fav(pte, keycode);
 		break;
 	case KEY_CONF:
-		HandleSelectCodec(pte);
+		handle_select_option(pte);
 		break;
 	case KEY_LOUDSPK:
 		send_select_output(pte, OUTPUT_SPEAKER, pte->device->volume, MUTE_OFF);
@@ -3284,44 +3996,41 @@
 	FILE *f;
 	char count;
 	long offset;
+	int flag = 0;
 
 	switch (keycode) {
-	case KEY_UP:
 	case KEY_LEFT:
+		if (pte->device->height == 1) {
+			if (pte->buff_entry[3] <= 1)
+				return;
+			pte->buff_entry[3]--;
+			flag = 1;
+			break;
+		}
+	case KEY_UP:
 	case KEY_FUNC1:
 		if (pte->buff_entry[2] <= 1)
 			return;
 		pte->buff_entry[2]--;
-		count = OpenHistory(pte, pte->buff_entry[0], &f);
-		if (!count)
-			return;
-		offset = ((pte->buff_entry[2] - 1) * TEXT_LENGTH_MAX * 3);
-		if (fseek(f, offset, SEEK_CUR)) {
-			display_last_error("Unable to seek history entry.");
-			fclose(f);
-			return;
-		}
-		show_entry_history(pte, &f);
+		flag = 1;
 		break;
-	case KEY_DOWN:
 	case KEY_RIGHT:
+		if (pte->device->height == 1) {
+			if (pte->buff_entry[3] == 3)
+				return;
+			pte->buff_entry[3]++;
+			flag = 1;
+			break;
+		}
+	case KEY_DOWN:
 	case KEY_FUNC2:
 		if (pte->buff_entry[2] >= pte->buff_entry[1])
 			return;
 		pte->buff_entry[2]++;
-		count = OpenHistory(pte, pte->buff_entry[0], &f);
-		if (!count)
-			return;
-		offset = ((pte->buff_entry[2] - 1) * TEXT_LENGTH_MAX * 3);
-		if (fseek(f, offset, SEEK_CUR)) {
-			display_last_error("Unable to seek history entry.");
-			fclose(f);
-			return;
-		}
-		show_entry_history(pte, &f);
+		flag = 1;
 		break;
 	case KEY_FUNC3:
-		if (!ReformatNumber(pte->device->lst_cid))
+		if (ast_strlen_zero(pte->device->lst_cid))
 			break;
 		ast_copy_string(pte->device->redial_number, pte->device->lst_cid,
 						sizeof(pte->device->redial_number));
@@ -3344,6 +4053,20 @@
 			show_history(pte, 'i');
 		break;
 	}
+
+	if (flag) {
+		count = open_history(pte, pte->buff_entry[0], &f);
+		if (!count)
+			return;
+		offset = ((pte->buff_entry[2] - 1) * TEXT_LENGTH_MAX * 3);
+		if (fseek(f, offset, SEEK_CUR)) {
+			display_last_error("Unable to seek history entry.");
+			fclose(f);
+			return;
+		}
+		show_entry_history(pte, &f);
+	}
+
 	return;
 }
 
@@ -3379,18 +4102,24 @@
 	send_client(SIZE_HEADER + sizeof(packet_send_S7), buffsend, pte);
 	send_led_update(pte, 0);
 	send_ping(pte);
+	if (unistimdebug)
+		ast_verb(0, "Sending init language\n");
+	if (pte->device) {
+		send_charset_update(pte, options_languages[find_language(pte->device->language)].encoding);
+	}
 	if (pte->state < STATE_MAINPAGE) {
 		if (autoprovisioning == AUTOPROVISIONING_TN) {
-			ShowExtensionPage(pte);
+			show_extension_page(pte);
 			return;
 		} else {
 			int i;
 			char tmp[30];
 
-			for (i = 1; i < 6; i++)
+			for (i = 1; i < 6; i++) {
 				send_favorite(i, 0, pte, "");
-			send_text(TEXT_LINE0, TEXT_NORMAL, pte, "Sorry, this phone is not");
-			send_text(TEXT_LINE1, TEXT_NORMAL, pte, "registered in unistim.cfg");
+			}
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, ustmtext("Phone is not registered", pte));
+			send_text(TEXT_LINE1, TEXT_NORMAL, pte, ustmtext("in unistim.conf", pte));
 			strcpy(tmp, "MAC = ");
 			strcat(tmp, pte->macaddr);
 			send_text(TEXT_LINE2, TEXT_NORMAL, pte, tmp);
@@ -3417,14 +4146,26 @@
 		rcv_resume_connection_with_server(pte);
 		return;
 	}
-	if (memcmp(buf + SIZE_HEADER, packet_recv_firm_version, sizeof(packet_recv_firm_version)) ==
-		0) {
+	if (memcmp(buf + SIZE_HEADER, packet_recv_firm_version, sizeof(packet_recv_firm_version)) == 0) {
 		buf[size] = 0;
 		if (unistimdebug)
 			ast_verb(0, "Got the firmware version : '%s'\n", buf + 13);
 		init_phone_step2(pte);
 		return;
 	}
+	if (memcmp(buf + SIZE_HEADER, packet_recv_it_type, sizeof(packet_recv_it_type)) == 0) {
+		char type = buf[13];
+		if (unistimdebug)
+			ast_verb(0, "Got the equipment type: '%d'\n", type);
+		switch (type) {
+		case 0x03: /* i2002 */
+			if (pte->device) {
+				pte->device->height = 1;
+			}
+			break;
+		}
+		return;
+	}
 	if (memcmp(buf + SIZE_HEADER, packet_recv_mac_addr, sizeof(packet_recv_mac_addr)) == 0) {
 		rcv_mac_addr(pte, buf);
 		return;
@@ -3444,8 +4185,8 @@
 		char keycode = buf[13];
 
 		if (unistimdebug)
-			ast_verb(0, "Key pressed : keycode = 0x%.2x - current state : %d\n", keycode,
-						pte->state);
+			ast_verb(0, "Key pressed: keycode = 0x%.2x - current state: %s\n", keycode,
+						ptestate_tostr(pte->state));
 
 		switch (pte->state) {
 		case STATE_INIT:
@@ -3471,9 +4212,15 @@
 		case STATE_EXTENSION:
 			key_select_extension(pte, keycode);
 			break;
+		case STATE_SELECTOPTION:
+			key_select_option(pte, keycode);
+			break;
 		case STATE_SELECTCODEC:
 			key_select_codec(pte, keycode);
 			break;
+		case STATE_SELECTLANGUAGE:
+			key_select_language(pte, keycode);
+			break;
 		case STATE_HISTORY:
 			key_history(pte, keycode);
 			break;
@@ -3492,13 +4239,14 @@
 			send_select_output(pte, OUTPUT_HEADPHONE, pte->device->volume, MUTE_OFF);
 		else
 			send_select_output(pte, OUTPUT_HANDSET, pte->device->volume, MUTE_OFF);
-		if (pte->state == STATE_RINGING)
-			HandleCallIncoming(pte);
-		else if ((pte->state == STATE_DIALPAGE) || (pte->state == STATE_CALL))
+		if (pte->state == STATE_RINGING) {
+			handle_call_incoming(pte);
+		} else if ((pte->state == STATE_DIALPAGE) || (pte->state == STATE_CALL))
 			send_select_output(pte, OUTPUT_HANDSET, pte->device->volume, MUTE_OFF);
 		else if (pte->state == STATE_EXTENSION) /* We must have a TN before calling */
 			return;
 		else {
+			pte->device->selected = get_avail_softkey(pte, NULL);
 			send_select_output(pte, OUTPUT_HANDSET, pte->device->volume, MUTE_OFF);
 			handle_dial_page(pte);
 		}
@@ -3510,14 +4258,15 @@
 		if (!pte->device)
 			return;
 		pte->device->receiver_state = STATE_ONHOOK;
-		if (pte->state == STATE_CALL)
-			close_call(pte);
-		else if (pte->device->lines->subs[SUB_REAL]->owner)
-			close_call(pte);
-		else if (pte->state == STATE_EXTENSION)
+		if (pte->state == STATE_CALL) {
+			if (pte->device->output != OUTPUT_SPEAKER) {
+				close_call(pte);
+			}
+		} else if (pte->state == STATE_EXTENSION) {
 			return;
-		else
+		} else {
 			show_main_page(pte);
+		}
 		return;
 	}
 	strcpy(tmpbuf, ast_inet_ntoa(pte->sin.sin_addr));
@@ -3703,28 +4452,71 @@
 		ast_log(LOG_WARNING, "Unistim callback function called without a device\n");
 		return NULL;
 	}
-	if (!sub->parent->parent->session) {
-		ast_log(LOG_WARNING, "Unistim callback function called without a session\n");
-		return NULL;
+	ast_mutex_lock(&sub->parent->parent->lock);
+	if (!sub->parent->parent->session) {
+		ast_log(LOG_WARNING, "Unistim callback function called without a session\n");
+		return NULL;
+	}
+	ast_mutex_unlock(&sub->parent->parent->lock);
+	return sub->parent->parent->session;
+}
+
+static void send_callerid_screen(struct unistimsession *pte, struct unistim_subchannel *sub) 
+{
+	char *cidname_str;
+	char *cidnum_str;
+
+	if (!sub) {
+		return;
+	}
+	if (sub->owner) {
+		if (sub->owner->connected.id.number.valid && sub->owner->connected.id.number.str) {
+			cidnum_str = sub->owner->connected.id.number.str;
+		} else {
+			cidnum_str = DEFAULTCALLERID;
+		}
+		change_callerid(pte, 0, cidnum_str);
+		if (strlen(cidnum_str) == 0) {
+			cidnum_str = DEFAULTCALLERID;
+		}
+
+		if (sub->owner->connected.id.name.valid && sub->owner->connected.id.name.str) {
+			cidname_str = sub->owner->connected.id.name.str;
+		} else {
+			cidname_str = DEFAULTCALLERNAME;
+		}
+		change_callerid(pte, 1, cidname_str);
+		if (strlen(cidname_str) == 0) {
+			cidname_str = DEFAULTCALLERNAME;
+		}
+
+		if (pte->device->height == 1) {
+			char tmpstr[256];
+			snprintf(tmpstr, sizeof(tmpstr), "%s %s", cidnum_str, ustmtext(cidname_str, pte));
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, tmpstr);
+		} else {
+			send_text(TEXT_LINE0, TEXT_NORMAL, pte, cidname_str);
+			send_text(TEXT_LINE1, TEXT_NORMAL, pte, ustmtext(cidnum_str, pte));
+		}
 	}
-	return sub->parent->parent->session;
 }
 
 /*--- unistim_call: Initiate UNISTIM call from PBX ---*/
 /*      used from the dial() application      */
 static int unistim_call(struct ast_channel *ast, char *dest, int timeout)
 {
-	int res = 0;
-	struct unistim_subchannel *sub;
+	int res = 0, i;
+	struct unistim_subchannel *sub, *sub_real;
 	struct unistimsession *session;
+	char ringstyle, ringvolume;
 
 	session = channel_to_session(ast);
 	if (!session) {
 		ast_log(LOG_ERROR, "Device not registered, cannot call %s\n", dest);
 		return -1;
 	}
-
 	sub = ast->tech_pvt;
+	sub_real = get_sub(session->device, SUB_REAL);
 	if ((ast->_state != AST_STATE_DOWN) && (ast->_state != AST_STATE_RESERVED)) {
 		ast_log(LOG_WARNING, "unistim_call called on %s, neither down nor reserved\n",
 				ast->name);
